// Generated by CoffeeScript 2.4.1
(function() {
  // Authenticate and authorize using a CouchDB backend
  // --------------------------------------------------
  var basic_auth, request,
    indexOf = [].indexOf;

  request = require('superagent');

  basic_auth = require('basic-auth');

  this.middleware = async function() {
    var admin_role, body, ref, ref1, user;
    // Skip if the session is already established.
    if (((ref = this.req.session) != null ? ref.couchdb_token : void 0) != null) {
      return;
    }
    // Skip if the user is not trying to authenticate using Basic.
    user = basic_auth(this.req);
    if (user == null) {
      return;
    }
    if (this.cfg.auth_base == null) {
      return;
    }
    // Try our method.

    // * cfg.admin_role (string) Role used to indicate a CouchDB account should be considered admin (see session.admin ). Default: `_admin`
    admin_role = (ref1 = this.cfg.admin_role) != null ? ref1 : '_admin';
    // * cfg.auth_base (URL without authentication) CouchDB base used to authenticate users (when basic auth is used).
    ({body} = (await request.get(`${this.cfg.auth_base}/_session`).accept('json').auth(user.name, user.pass)));
    this.req.session = {};
    this.req.session.couchdb_username = body.userCtx.name;
    this.req.session.couchdb_roles = body.userCtx.roles;
    this.req.session.admin = indexOf.call(this.req.session.couchdb_roles, admin_role) >= 0;
  };

  // Do not mask errors in the remaining middlewares.

}).call(this);
